### Name: with.jobjRef
### Title: with and within methods for Java objects and class names
### Aliases: with.jobjRef within.jobjRef with.jarrayRef within.jarrayRef
###   with.jclassName within.jclassName
### Keywords: classes

### ** Examples

## Not run: 
##D 
##D p <- .jnew( "java/awt/Point", 0L, 0L )
##D with( p, {
##D         # x and y and now 0
##D         move( 10L, 10L )
##D         # x and y are now 10
##D         x <- x + y
##D } )
##D 
##D f <- within( .jnew( "javax/swing/JFrame" ) , {
##D         layout <- .jnew( "java/awt/BorderLayout" )
##D         setLayout( layout )
##D         add( .jnew( "javax/swing/JLabel", "north" ), layout$NORTH )
##D         add( .jnew( "javax/swing/JLabel", "south" ), layout$SOUTH )
##D         add( .jnew( "javax/swing/JLabel", "west" ), layout$WEST )
##D         add( .jnew( "javax/swing/JLabel", "east" ), layout$EAST )
##D         setSize( .jnew( "java/awt/Dimension", 400L, 400L ) )
##D         setVisible( TRUE )
##D } )
## End(Not run)

## Don't show: 
.jinit()
## End Don't show

Double <- J("java.lang.Double")
with( Double, MIN_VALUE )
with( Double, parseDouble( "10.2" ) )

## Not run: 
##D # inner class example
##D HashMap <- J("java.util.HashMap")
##D with( HashMap, new( SimpleEntry, "key", "value" ) )
##D with( HashMap, SimpleEntry )
## End(Not run)

with( J("java.lang.System"), getProperty("java.home") )

## Don't show: 
stopifnot( with( Double, parseDouble("10.0") ) == 10.0 )
d <- new( Double, "10.0") 
stopifnot( with( d, doubleValue() ) == 10.0 )
## End Don't show




